#ifndef ___CONFIG_H___
#define ___CONFIG_H___

#include <QString>
#include <QVector>

#define CIPH_TYPE_AUTO  0x88888

struct Config
{
    // General
    QString last_directory_open;
    QString last_directory_save;
    QString last_directory_export;
    QString last_directory_import;
    int last_silence_total;
    QVector<int> last_silence_select;

    // Decoder
    bool preserve_loop;
    bool use_float;
    int bit_depth;

    // Encoder
    int quality;
    int cutoff_freq;

    // Import
    int ciph_type;
    bool last_was_looped;
    bool use_input_loop;

    void Load();
    void Save();
};

extern Config config;

#endif // ___CONFIG_H___
