#ifndef LOOPDIALOG_H
#define LOOPDIALOG_H

#include <QDialog>
#include <QTime>
#include "AudioFile.h"

namespace Ui {
class LoopDialog;
}

class LoopDialog : public QDialog
{
    Q_OBJECT

public:
     LoopDialog(QWidget *parent, QVector<AudioFile *> files);
    ~LoopDialog();

    static QTime SecondsToQTime(float time);
    static float QTimeToSeconds(const QTime &time);

private slots:
    void on_hasLoop_toggled(bool checked);

    void on_buttonBox_rejected();

    void on_buttonBox_accepted();

private:
    Ui::LoopDialog *ui;

    QVector<AudioFile *> files;
    QTime start, end, zero, max;
    int loop_count;

    bool IsModified() const;
};

#endif // LOOPDIALOG_H
