#include "loopquestiondialog.h"
#include "ui_loopquestiondialog.h"

#include "debug.h"

LoopQuestionDialog::LoopQuestionDialog(QWidget *parent, bool default_loop, bool use_input_loop) :
    QDialog(parent),
    ui(new Ui::LoopQuestionDialog)
{
    ui->setupUi(this);
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);

    ui->loopButton->setDefault(default_loop);
    ui->dontloopButton->setDefault(!default_loop);
    ui->inputLoopCheckBox->setChecked(use_input_loop);
}

LoopQuestionDialog::~LoopQuestionDialog()
{
    delete ui;
}

void LoopQuestionDialog::on_LoopQuestionDialog_rejected()
{
    //done(0);
}

void LoopQuestionDialog::on_loopButton_clicked()
{
    int flags = 1;

    if (ui->inputLoopCheckBox->isChecked())
        flags |= USE_INPUT_LOOP;

    done(flags);
}

void LoopQuestionDialog::on_dontloopButton_clicked()
{
    done(0);
}
