#include "selectsilencedialog.h"
#include "ui_selectsilencedialog.h"

#include <assert.h>
#include "debug.h"

SelectSilenceDialog::SelectSilenceDialog(QWidget *parent, const QVector<QString> &tracks, QVector<int> *select, int num_silence) :
    QDialog(parent), select(select), num_silence(num_silence),
    ui(new Ui::SelectSilenceDialog)
{
    ui->setupUi(this);
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);

    assert(tracks.size() >= 1 && tracks.size() <= 8);
    assert(tracks.size() == select->size());

    boxes.resize(8);

    for (int i = 0; i < 8; i++)
    {
        if (i == 0)
        {
            boxes[i] = ui->checkBox1;
        }
        else if (i == 1)
        {
            boxes[i] = ui->checkBox2;
        }
        else if (i == 2)
        {
            boxes[i] = ui->checkBox3;
        }
        else if (i == 3)
        {
            boxes[i] = ui->checkBox4;
        }
        else if (i == 4)
        {
            boxes[i] = ui->checkBox5;
        }
        else if (i == 5)
        {
            boxes[i] = ui->checkBox6;
        }
        else if (i == 6)
        {
            boxes[i] = ui->checkBox7;
        }
        else
        {
            boxes[i] = ui->checkBox8;
        }

        if (i < tracks.size())
        {
            boxes[i]->setText(tracks[i]);

            if ((*select)[i])
                boxes[i]->setChecked(true);
        }
        else
        {
            boxes[i]->setHidden(true);
        }
    }

    ui->instructionsLabel->setText(QString("Check the tracks that will be silenced. You must check exactly %1 tracks.").arg(num_silence));
}

SelectSilenceDialog::~SelectSilenceDialog()
{
    delete ui;
}

void SelectSilenceDialog::on_okButton_clicked()
{
    int count = 0;

    for (int i = 0; i < (int)select->size(); i++)
    {
        if (boxes[i]->isChecked())
        {
            count++;
            (*select)[i] = true;
        }
        else
        {
            (*select)[i] = false;
        }
    }

    if (count != num_silence)
    {
        DPRINTF("You must check exactly %d tracks.\n", num_silence);
        return;
    }

    done(1);
}
