#include <algorithm>
#include "Xv2PreBakedFile.h"
#include "debug.h"

Xv2PreBakedFile::Xv2PreBakedFile()
{

}

Xv2PreBakedFile::~Xv2PreBakedFile()
{

}

void Xv2PreBakedFile::Reset()
{
    ozarus.clear();
}

TiXmlDocument *Xv2PreBakedFile::Decompile() const
{
    TiXmlDocument *doc = new TiXmlDocument();

    TiXmlDeclaration* decl = new TiXmlDeclaration("1.0", "utf-8", "" );
    doc->LinkEndChild(decl);

    TiXmlElement *root = new TiXmlElement("Xv2PreBaked");
    Utils::WriteComment(root, "This file is used by xv2patcher and XV2 Mods Installer. It defines characters data that only exist in exe at runtime. ");
    Utils::WriteComment(root, "--------------------------------------------");

    Utils::WriteComment(root, "This is the list of additional ozarus to add to the game.");
    Utils::WriteParamMultipleStrings(root, "OZARUS", ozarus);

    doc->LinkEndChild(root);
    return doc;
}

bool Xv2PreBakedFile::Compile(TiXmlDocument *doc, bool)
{
    Reset();

    TiXmlHandle handle(doc);
    const TiXmlElement *root = Utils::FindRoot(&handle, "Xv2PreBaked");

    if (!root)
    {
        DPRINTF("Cannot find\"Xv2PreBaked\" in xml.\n");
        return false;
    }

    Utils::ReadParamMultipleStrings(root, "OZARUS", ozarus);

    return true;
}

void Xv2PreBakedFile::AddOzaru(const std::string &ozaru)
{
    if (std::find(ozarus.begin(), ozarus.end(), ozaru) != ozarus.end())
        return;

    ozarus.push_back(ozaru);
}

void Xv2PreBakedFile::RemoveOzaru(const std::string &ozaru)
{
    for (size_t i = 0; i < ozarus.size(); i++)
    {
        if (ozarus[i] == ozaru)
        {
            ozarus.erase(ozarus.begin()+i);
            i--;
        }
    }
}
