#ifndef XV2PREBAKEDFILE_H
#define XV2PREBAKEDFILE_H

#include "BaseFile.h"

class Xv2PreBakedFile : public BaseFile
{
private:

    std::vector<std::string> ozarus;

protected:

    void Reset();

public:

    Xv2PreBakedFile();
    virtual ~Xv2PreBakedFile();

    virtual TiXmlDocument *Decompile() const override;
    virtual bool Compile(TiXmlDocument *doc, bool big_endian=false) override;

    inline const std::vector<std::string> &GetOzarus() const { return ozarus; }
    inline std::vector<std::string> &GetOzarus() { return ozarus; }

    void AddOzaru(const std::string &ozaru);
    void RemoveOzaru(const std::string &ozaru);
};

#endif // XV2PREBAKEDFILE_H
