#pragma once

//--------------------------------------------------
// HCA(High Compression Audio)NX
//--------------------------------------------------
class clHCA{
public:
	clHCA(unsigned int ciphKey1,unsigned int ciphKey2);

	// HCA`FbN
	static bool CheckFile(void *data,unsigned int size);

	// `FbNT
	static unsigned short CheckSum(void *data,int size,unsigned short sum=0);

	// wb_R\[o
	bool PrintInfo(const char *filenameHCA);

	// fR[hWAVEt@Cɕۑ
	bool DecodeToWavefile(const char *filenameHCA,const char *filenameWAV,float volume=1,int mode=16,int loop=0);

private:
	struct stHeader{//t@C (K{)
		unsigned int hca;              // 'HCA'
		unsigned short version;        // o[WBv1.3v2.0݂̑mF
		unsigned short dataOffset;     // f[^ItZbg
	};
	struct stFormat{//tH[}bg (K{)
		unsigned int fmt;              // 'fmt'
		unsigned int channelCount:8;   // `l 1`16
		unsigned int samplingRate:24;  // TvO[g 1`0x7FFFFF
		unsigned int blockCount;       // ubN 0ȏ
		unsigned short r01;            // 擪̖(ubN*0x400+0x80)
		unsigned short r02;            // ̖HvZ@s(0x226)
	};
	struct stCompress{//k (k񂩃fR[ĥǂ炩K{)
		unsigned int comp;             // 'comp'
		unsigned short blockSize;      // ubNTCY(CBR̂ƂɗLH) 8`0xFFFFA0̂ƂVBR
		unsigned char r01;             // s(1) 0`r02      v2.01̂ݑΉ
		unsigned char r02;             // s(15) r01`0x1F  v2.015̂ݑΉ
		unsigned char r03;             // s(1)(1)
		unsigned char r04;             // s(1)(0)
		unsigned char r05;             // s(0x80)(0x80)
		unsigned char r06;             // s(0x80)(0x20)
		unsigned char r07;             // s(0)(0x20)
		unsigned char r08;             // s(0)(8)
		unsigned char reserve1;        // \
		unsigned char reserve2;        // \
	};
	struct stDecode{//fR[h (k񂩃fR[ĥǂ炩K{)
		unsigned int dec;              // 'dec'
		unsigned short blockSize;      // ubNTCY(CBR̂ƂɗLH) 8`0xFFFFA0̂ƂVBR
		unsigned char r01;             // s(1) 0`r02      v2.01̂ݑΉ
		unsigned char r02;             // s(15) r01`0x1F  v2.015̂ݑΉ
		unsigned char count1;          // type0type1̐-1
		unsigned char count2;          // type2̐-1
		unsigned char r03:4;           // s(0)
		unsigned char r04:4;           // s(0) 01ɏC
		unsigned char enableCount2;    // count2gtO
	};
	struct stVBR{//σrbg[g (p~H)
		unsigned int vbr;              // 'vbr'
		unsigned short r01;            // s 0`0x1FF
		unsigned short r02;            // s
	};
	struct stATH{//ATHe[u (v2.0p~H)
		unsigned int ath;              // 'ath'
		unsigned short type;           // e[u̎(0:S0 1:e[u1)
	};
	struct stLoop{//[v
		unsigned int loop;             // 'loop'
		unsigned int loopStart;        // [vJnubNCfbNX 0`loopEnd
		unsigned int loopEnd;          // [vIubNCfbNX loopStart`(stFormat::blockCount-1)
		unsigned short r01;            // s(0x80)[vtOH[v񐔁H
		unsigned short r02;            // s(0x226)
	};
	struct stCipher{//Íe[u
		unsigned int ciph;             // 'ciph'
		unsigned short type;           // Í̎(0:ÍȂ 1:ȂÍ 0x38:Í)
	};
	struct stRVA{//΃{[ߏ
		unsigned int rva;              // 'rva'
		float volume;                  // {[
	};
	struct stComment{//Rg
		unsigned int comm;             // 'comm'
		unsigned char len;             // Rg̒H
		//char comment[];
	};
	struct stPadding{//pfBO
		unsigned int pad;              // 'pad'
	};
	unsigned int _version;
	unsigned int _dataOffset;
	unsigned int _channelCount;
	unsigned int _samplingRate;
	unsigned int _blockCount;
	unsigned int _fmt_r01;
	unsigned int _fmt_r02;
	unsigned int _blockSize;
	unsigned int _comp_r01;
	unsigned int _comp_r02;
	unsigned int _comp_r03;
	unsigned int _comp_r04;
	unsigned int _comp_r05;
	unsigned int _comp_r06;
	unsigned int _comp_r07;
	unsigned int _comp_r08;
	unsigned int _comp_r09;
	unsigned int _vbr_r01;
	unsigned int _vbr_r02;
	unsigned int _ath_type;
	unsigned int _loopStart;
	unsigned int _loopEnd;
	unsigned int _loop_r01;
	unsigned int _loop_r02;
	bool _loopFlg;
	unsigned int _ciph_type;
	unsigned int _ciph_key1;
	unsigned int _ciph_key2;
	float _rva_volume;
	unsigned int _comm_len;
	char *_comm_comment;
	class clATH{
	public:
		clATH();
		bool Init(int type,unsigned int key);
		unsigned char *GetTable(void);
	private:
		unsigned char _table[0x80];
		void Init0(void);
		void Init1(unsigned int key);
	}_ath;
	class clCipher{
	public:
		clCipher();
		bool Init(int type,unsigned int key1,unsigned int key2);
		void Mask(void *data,int size);
	private:
		unsigned char _table[0x100];
		void Init0(void);
		void Init1(void);
		void Init56(unsigned int key1,unsigned int key2);
		void Init56_CreateTable(unsigned char *table,unsigned char key);
	}_cipher;
	class clData{
	public:
		clData(void *data,int size);
		int CheckBit(int bitSize);
		int GetBit(int bitSize);
		void AddBit(int bitSize);
	private:
		unsigned char *_data;
		int _size;
		int _bit;
	};
	struct stChannel{
		float block[0x80];
		float base[0x80];
		char value[0x80];
		char scale[0x80];
		char value2[8];
		int type;
		char *value3;
		unsigned int count;
		float wav1[0x80];
		float wav2[0x80];
		float wav3[0x80];
		float wave[8][0x80];
		void Decode1(clData *data,unsigned int a,int b,unsigned char *ath);
		void Decode2(clData *data);
		void Decode3(unsigned int a,unsigned int b,unsigned int c,unsigned int d);
		void Decode4(int index,unsigned int a,unsigned int b,unsigned int c);
		void Decode5(int index);
	}_channel[0x10];
	bool Decode(void *data,unsigned int size,unsigned int address);
	bool DecodeToWavefile_Decode(void *fp1,void *fp2,unsigned int address,unsigned int count,void *data,void *modeFunction);
	static void DecodeToWavefile_DecodeModeFloat(float f,void *fp);
	static void DecodeToWavefile_DecodeMode8bit(float f,void *fp);
	static void DecodeToWavefile_DecodeMode16bit(float f,void *fp);
	static void DecodeToWavefile_DecodeMode24bit(float f,void *fp);
	static void DecodeToWavefile_DecodeMode32bit(float f,void *fp);
};
